#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iterator>
#include <map>

#ifndef INCLUDED_BEDELINGEN_H_
#define INCLUDED_BEDELINGEN_H_

class Bedelingen
{
      int                      d_available[5];
      std::vector<std::string> d_bedelingen;
      int                      d_range_min;
      int                      d_range_max;

      public:
           Bedelingen()  
           {
                setAvailable(4,4,4,4);
           }
                   
           Bedelingen(int Aces, int Kings, int Queens, int Jacks)
           {
                setAvailable(Aces,Kings,Queens,Jacks);
           }
           
           void setAvailable(int Aces, int Kings, int Queens, int Jacks)
           {
                d_available[0] = -1;               
                d_available[1] = Jacks;               
                d_available[2] = Queens;               
                d_available[3] = Kings;
                d_available[4] = Aces;                   
           }
           
           void bereken(int min, int max);
      
           std::vector<std::string> &bedeling()
           {
                return d_bedelingen;
           }
      
           void showrange(std::ostream &out)
           {
                out << d_range_min << "-" << d_range_max << "pts" << std::endl;
           }
           
           void own();
           
      private:
           void berekenHand(int hcps);
           int highestAvailable();
           std::string highestHand(int points, int highestcard, std::string current, bool &partial);
           char symbol(int card);
           std::string breek(std::string hand);
           char decrement(char c);
           std::string vulaan(std::string hand, int points);
};

#endif
