#include "player.ih"

void player::evaluateHand()
{
    // initialising frequency-count
    for(int s = card::Clubs; s <= card::Spades ; ++s)
    {
        suitfrequencies[s].first  = 0;   
        suitfrequencies[s].second = s;
    }

    // counting suitfrequencies and counting points
    for(unsigned idx = 0; idx < d_cards.size(); ++idx)
    {
        d_points += d_cards[idx].getPoints();     
        ++suitfrequencies[d_cards[idx].getSuit()].first;    
    }
    
    // subtracting own hand from knowledge of other players:
    int aces(0),kings(0),queens(0),jacks(0);
    for (unsigned idx = 0; idx < d_cards.size(); ++idx)
    {
        switch (d_cards[idx].getValue())
        {
               case card::A:
                    aces++;
                    break;
               case card::K:
                    kings++;
                    break;
               case card::Q:
                    queens++;
                    break;
               case card::J:
                    jacks++;
                    break;
               default:
                    break;
        }
    }

    d_knowledge.setAvailable(4 - aces, 4 - kings, 4 - queens, 4 - jacks);


    // considdering NT-distribution
    if(suitfrequencies[card::Clubs].first == 5 || suitfrequencies[card::Diamonds].first == 5)
    {
        sort(suitfrequencies, suitfrequencies + 4);    
        if(suitfrequencies[1].first == 3 && suitfrequencies[2].first == 3)
            d_NTDistribution = true;
    }    
    else
    {
        sort(suitfrequencies, suitfrequencies + 4);
        if(suitfrequencies[3].first == 4 && suitfrequencies[2].first == 4 &&  suitfrequencies[1].first == 3)
            d_NTDistribution = true;
        else if(suitfrequencies[3].first == 4 && suitfrequencies[2].first == 3 && suitfrequencies[1].first == 3)
            d_NTDistribution = true;
    }    

    // printing distibution
    cout << "distribution: " <<suitfrequencies[0].first  << "(";
    printSuit(cout, suitfrequencies[0].second);
                cout << ")-" << suitfrequencies[1].first << "(";
    printSuit(cout, suitfrequencies[1].second);
                cout << ")-" << suitfrequencies[2].first << "(";
    printSuit(cout, suitfrequencies[2].second);
                cout << ")-" << suitfrequencies[3].first << "(";
    printSuit(cout, suitfrequencies[3].second);
                cout << ")";
    
    
    if(d_NTDistribution)
        cout << "\tthis is a NT distribution.";
       
    cout << endl;    
}

