#include "player.ih"

void player::infer(int player, pair<int,int> bid, pair<int,int> openingBid, bool friendly)
{
  if(bid == openingBid) // the bid is the opening bid
  {
    switch(bid.first)
    {
        case 0:
                 d_knowledge.update_range(player, 0, 12); // in case of "pass"
                 break;
             
        case 1:
             if(bid.second == 4)
                 d_knowledge.update_range(player, 15, 17); // in case of "1 NT"
             else
                 d_knowledge.update_range(player, 13, 19); // in case of "1 suit"    
                 break;
        
        case 2:
             if(bid.second == 0)
                 d_knowledge.update_range(player, 23, 40); // in case of "2 clubs"
             else if(bid.second == 4)
                 d_knowledge.update_range(player, 20, 22); // in case of "2 NT"    
             else
                 d_knowledge.update_range(player, 20, 22); // in case of "2 D/H/S"
                 break;
    }
  } // if openingbid close
  
  else // the bid is a  reply to the opening bid
  {
      if(friendly)
      {
          if(openingBid.first == 1 && openingBid.second != 4) // openingBid was "1 suit"
          {
              switch(bid.first)
              {
                case 0: // in case of "pass"
                  if(d_lastBid.first == 1 && d_lastBid.second != 4)
                      d_knowledge.update_range(player, 0, 5); 
                  if(d_lastBid.first == 2 && player != d_knowledge.getOpener() )
                      d_knowledge.update_range(player, 0, 9); 
                  break;
                case 1:
                  if(bid.second == 4) 
                      d_knowledge.update_range(player, 6, 9); // in case of "1 NT" 
                  else if(player != d_knowledge.getOpener() )
                      d_knowledge.update_range(player, 6, 9); // in case of "1 suit"     
                  break;
                
                case 2:
                  if(bid.second == 4)
                      d_knowledge.update_range(player, 10, 11); // in case of "2 NT"   
                  else if(player == d_knowledge.getOpener() )
                      d_knowledge.update_range(player, 11, 40); // in case of "2 NT"   
                  else if (bid.second == openingBid.second)
                      d_knowledge.update_range(player, 6, 9); // in case of "2 in same suit"   
                  else 
                      d_knowledge.update_range(player, 10, 27); // in case of "2 in different suit"   
                  break;
                 
                case 3:
                  if(bid.second == openingBid.second && player != d_knowledge.getOpener() )
                      d_knowledge.update_range(player, 10, 11); // in case of "3 in same suit"   
                  else
                      d_knowledge.update_range(player, 12, 40); // in case of "3 in other suit"   
                  break;
                case 4:
                      d_knowledge.update_range(player, 12, 40); // in case of "3 in other suit"  
                       
              }
          } // if, openingbid was 1 suit close
    
          if(openingBid.first == 1 && openingBid.second == 4) // opening was 1 NT
          {
              switch(bid.first)
              {
                case 0: // in case of "pass"
                      d_knowledge.update_range(player, 0, 8); 
                  break;
                case 2:
                  if(bid.second == 4)
                      d_knowledge.update_range(player, 9, 9); // in case of "2 NT"  
                  else if ( bid.second == 0)
                      d_knowledge.update_range(player, 8, 27); // in case of "2 clubs"   
                  else
                      d_knowledge.update_range(player, 0, 7); // in case of "2 suit"
                  break;
                case 3:
                  if(bid.second == 4)
                      d_knowledge.update_range(player, 10, 15); // in case of "3 NT"
                  else
                      d_knowledge.update_range(player, 8, 10); // in case of "3 suit"     
                  break;
              }
          } // if openingbid was 1 NT close
    
          if(openingBid.first == 2 && openingBid.second == 0) // openingbid was 2 clubs
          {
              if(bid.first == 2 && bid.second == 1)
                  d_knowledge.update_range(player, 0, 6); // in case of "2 diamond"   
              else
                  d_knowledge.update_range(player, 6, 17); // in other cases.         
          } // if opening was 2 clubs close

          else if(openingBid.first == 2 && openingBid.second == 4) // openingbid was 2 NT
          {
              if(bid.first == 0)
                  d_knowledge.update_range(player, 0, 4); // in case of "pass"   
              else if (bid.first == 3)
              {
                  if(bid.second == 4)
                      d_knowledge.update_range(player, 5, 11); // in case of 3 NT
                  else
                      d_knowledge.update_range(player, 4, 20); // in case of 3 suit
              }
          } // if opening was 2 NT close
    
          else if(openingBid.first == 2) // openingbid was 2 D/H/S
          {
              if(bid.first == 2 && bid.second == 4)
                  d_knowledge.update_range(player, 0, 5); // in case of 2 NT
              else
                  d_knowledge.update_range(player, 6, 40);
          }// openingbid was 2 D/H/S close
          
      }// if bid was friendly close
      
      else if(openingBid.first == 1 && openingBid.second == 2) // bid was not friendly
      {
          switch(bid.first)
          {
            case 0:
              d_knowledge.update_range(player, 0,12);
              break;
            case 1:
              if(bid.second == 4)
                  d_knowledge.update_range(player, 15, 17);
              else
                  d_knowledge.update_range(player, 8, 12);
              break;
            case 2:
              if(bid.second == 4)
                  d_knowledge.update_range(player, 18, 40);
              else
                  d_knowledge.update_range(player, 13, 16);
              break;
          }
      }// else, no friendly bid, close
  } // else, no opening bid close
  
  for(int cur_player = 0; cur_player < 4; ++cur_player)
  {
      int tot_max_others = 0;
      int tot_min_others = 0;          
          
      for(int other_player = 0; other_player < 4; ++other_player)
      {
          if(cur_player != other_player)
          {
              tot_max_others += d_knowledge.kmax(other_player);
              tot_min_others += d_knowledge.kmin(other_player);
          }
      }
      d_knowledge.update_range(cur_player, 40 - tot_max_others, 40 - tot_min_others);  
  }
  
  
  d_lastBid = bid;
}
