#include "knowledge.ih"
#include <iostream>

knowledge::knowledge(int player)
{     
    for(int idx = 0; idx <= 40; ++idx)
    {
        d_know[0][idx] = 1;
        d_know[1][idx] = 1;
        d_know[2][idx] = 1;
        d_know[3][idx] = 1;        
    }
    d_owner = player;
}    
    
void knowledge::update(int X, int Y) // player X doenst have Y points
{
    d_know[X][Y]= 0;
}

void knowledge::set(int X, int Y) // player X has exactly Y points
{
     for(int idx = 0; idx <= 40; ++idx)
         d_know[X][idx] = idx == Y;
}

void knowledge::update_range(int X, int Y_lower, int Y_higher) // player X's points range from Y_lower to Y_higher
{
     if (X == d_owner)
     {
        return;
     }

     for(int idx = 0; idx <= 40; ++idx)
     {
         int write = (idx >= Y_lower && idx <= Y_higher);
         if(!write)
             d_know[X][idx] = write;
     }
}

void knowledge::print()
{
     cout << "punten: \t0                   1                   2                   3                   4" << endl; 
     cout << "spelers:\t0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 4\n" << endl;  
       
     for(int player = 0; player < 4; ++player)
     {
         cout << "player " << player << ":\t";    
         for(int idx = 0; idx <= 40; ++idx)
             cout << d_know[player][idx] << " ";
         cout << endl;
     }
     
     for (int player = 0; player < 4; ++player)
     {
         if (player != d_owner)
         {
             d_bedelingen[player].bereken(kmin(player),kmax(player));
         }
         else
             d_bedelingen[player].own();
     }

     combine();
    
     unique_copy(d_combined.begin(),
                 d_combined.end(),
                 ostream_iterator<string>(cout, " ") );
     cout << "\nplayer " << d_owner << " kan " << d_combined.size() << " mogelijkheden(werelden) niet van elkaar onderscheiden.\n";
}

void knowledge::combine()
{
     cout << "combining knowledge" << endl;
     
     copy(d_bedelingen[0].bedeling().begin(),d_bedelingen[0].bedeling().end(),back_inserter(d_combined));     
     
     for (int player = 1; player < 4; ++player)
     {
         vector<string> temp;

         for (vector<string>::iterator iter = d_combined.begin(); 
              iter != d_combined.end(); 
              ++iter)
         {
              for (vector<string>::iterator it = d_bedelingen[player].bedeling().begin();
                   it != d_bedelingen[player].bedeling().end();
                   ++it )
              {
                     string reeks = (*iter) + "|" + (*it);  
                   
                     if (checkRij(reeks, player == 3))
                        temp.push_back(reeks);
              }
         }
         
         d_combined.erase(d_combined.begin(), d_combined.end());
            
         copy(temp.begin(), temp.end(), back_inserter(d_combined));   
     }
}

bool knowledge::checkRij(string hand, bool full)
{
     unsigned pos = 0;
     int A(0),K(0),Q(0),J(0);
     while (pos < hand.size())
     {
         char card = hand.at(pos);
         switch (card)
         {
              case 'A':
                   A++;
                   break;
              case 'K':
                   K++;
                   break;
              case 'Q':
                   Q++;
                   break;
              case 'J':
                   J++;
                   break;
         }
         ++pos;
     }
     
     if (full)
     {
        if ( A == 4 && K == 4 && Q == 4 && J == 4)
        {
           return true;
           }
     }
     else
     {
        if ( A < 5 && K < 5 && Q < 5 && J < 5 )
        { 
           return true;
        }
     }

     return false;   
}
























/*

      
    vector <card>ownCards;  
    vector <card>restCards;
      
      
    fillRestCards(vector <card>cards, int id)
    {
        owncards = cards;                 
        for(int num = card::Two; num <= card::A; ++num)
        {
            for(int suit = card::Clubs; suit <= card::Spades; ++suit)
            {    
                card curCard(num, suit); 
                for(int idx = 0; idx < cards.size(); ++idx)
                {
                    if(curCard != cards[idx])
                        restCards.push_back(curCard);
                }
            }
        }
    }


*/
